package dyswis;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import packetsniffer.Pcap;
import packetsniffer.PcapIf;
import packetsniffer.PcapPacket;
import packetsniffer.PcapPacketHandler;

public class BytesExchanged implements Runnable {
	
	private static WLANInterface wlan;
	
	public BytesExchanged(){
		wlan = WLANInterface.getWLANInterfaceObject();
	}
	
	public static void updateBytesExchanged(long bytes){
		wlan.setBytesExchanged(bytes);
	}
	
	public void run(){
		List<PcapIf> alldevs = new ArrayList<PcapIf>(); // Will be filled with NICs  
        StringBuilder errbuf = new StringBuilder(); // For any error msgs  
  
        /*************************************************************************** 
         * First get a list of devices on this system 
         **************************************************************************/  
        int r = Pcap.findAllDevs(alldevs, errbuf);
        PcapIf device = alldevs.get(1);
        
        /*************************************************************************** 
         * Second we open up the selected device 
         **************************************************************************/  
        int snaplen = 64 * 1024;           // Capture all packets, no trucation  
        int flags = Pcap.MODE_PROMISCUOUS; // capture all packets  
        int timeout = 10 * 1000;           // 10 seconds in millis  
        Pcap pcap =  
            Pcap.openLive(device.getName(), snaplen, flags, timeout, errbuf);  
  
        if (pcap == null) {  
            System.err.printf("Error while opening device for capture: "  
                + errbuf.toString());  
            return;  
        }
        PcapPacketHandler<String> jpacketHandler = new PcapPacketHandler<String>() {  
        	  
            public void nextPacket(PcapPacket packet, String user) {  
            	BytesExchanged.wlan.setBytesExchanged(packet.getCaptureHeader().wirelen());
            }  
        };
        
        while(true){
        	pcap.loop(10, jpacketHandler, "Packet captured");  
        	  
        }
        /*************************************************************************** 
         * Last thing to do is close the pcap handle 
         **************************************************************************/  
        pcap.close(); 
    
	}
}
