package dyswis;

import java.util.HashMap;

public class DYSWIS {
	
	private WLANInterfaceQ wlanQ;
	private InferenceEngine iEngine;
	
	/*
	 * Map of WLANInterface with IP address of Peers as Keys
	 */
	private HashMap <String, WLANInterface> peers;
	
	public HashMap<String, WLANInterface> getPeers() {
		return peers;
	}

	public void setPeers(HashMap<String, WLANInterface> peers) {
		this.peers = peers;
	}
	
	public void addPeer(String IPAddress, WLANInterface peerWlan){
		peers.put(IPAddress, peerWlan);
	}
	
	public void removePeer(String IPAddress){
		peers.remove(IPAddress);
	}


	public DYSWIS(){
		/*
		 * Starts threads that record the signal quality and bytes exchanged
		 */
		wlanQ = new WLANInterfaceQ();
		iEngine = new InferenceEngine(wlanQ);
		(new Thread(wlanQ)).start();
//		(new Thread(new BytesExchanged())).start();
	}
	
	public void runDiagnosis(){
		/*
		 * This function is called when a fault is detected and analysis is required.
		 */
		iEngine.runDiagnosis(peers);
	}
}
