package dyswis;

import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;

public class InferenceEngine {
	private WLANInterfaceQ wlanQ;
	
	public InferenceEngine(){
	}
	
	public InferenceEngine(WLANInterfaceQ wlanQ){
		this.wlanQ = wlanQ;
	}
	
	public void runDiagnosis(HashMap<String, WLANInterface> peers){
		double signalStandardDev = wlanQ.getWlan().getSignalStandardDeviation();
		double mean = wlanQ.getWlan().getMeanSignalStrength();
		double peerSd;
		/*******************************************************
		 * Checks to see if there is any RF interference in the*
		 * environment, either local or at access point        *
		 *******************************************************/
		if(signalStandardDev > 3){
			int peerRfCount = 0;
			//Iterate through peers to see how many have sd > 3
			Collection c = peers.values();
			   
		    //obtain an Iterator for Collection
		    Iterator itr = c.iterator();
		   
		    //iterate through HashMap values iterator
		    while(itr.hasNext()){
		    	
		    	peerSd = ((WLANInterface) itr.next()).getSignalStandardDeviation();
		    	if(peerSd > 3){
		    		peerRfCount++;
		    	}
		    }
		    if(peerRfCount > peers.size()/2){
		    	System.out.println("RF Interference at Multiple Hosts");
		    }
		    else{
		    	System.out.println("RF Interference at Local Environment");
		    }
			
		}
		else if(mean < -80){
			System.out.println("Too far from Access Point");
		}
		
	}
}
